import java.util.*;
import java.rmi.server.UnicastRemoteObject;
import java.rmi.*;

@SuppressWarnings("unchecked")

public class MessageQueue extends UnicastRemoteObject implements RemoteChannel
{

    private Vector queue;

    public MessageQueue() throws RemoteException {
        queue = new Vector();
    }

    public synchronized void send(Object item) throws RemoteException {
        // This implements a non-blocking send public synchronized void send(Object item)
        System.out.println("Message " + item + " sent.");
        queue.addElement(item);
    }

    public synchronized Object receive() throws RemoteException {
        if (queue.size() == 0)
            return null;
        else
        {
            Object received = queue.remove(0);
            System.out.println("Message " + received + " received.");
            return received;
        }
    }

    public static void main(String args[]) { try {
            RemoteChannel server = new MessageQueue();
            // Bind this object instance to the name "MessageQueue"
            Naming.rebind("MessageQueue", server); 
            System.out.println("Server Bound");
        }
        catch(Exception e) {
            System.err.println(e);
        } 
    }
}